select TCLNP.ANCESTOR_ID, TCLN.TCLN_ID, TCLN.PROJECT_ID, TCLN.NAME, TCLN.DESCRIPTION
from TEST_CASE_LIBRARY_NODE TCLN
inner join TEST_CASE_FOLDER TCF on TCLN.TCLN_ID = TCF.TCLN_ID
left join TCLN_RELATIONSHIP TCLNP on TCLNP.DESCENDANT_ID = TCLN.TCLN_ID
where TCLN.TCLN_ID in (
	SELECT TCLN2.ANCESTOR_ID
	from TCLN_RELATIONSHIP_CLOSURE TCLN2
	inner join TEST_CASE TC2 on TCLN2.DESCENDANT_ID = TC2.TCLN_ID
	where TC2.TCLN_ID in (:testcaseIds)
) 
